package com.tatacommunications.tp.jcm.listener;


import javax.annotation.Resource;
import javax.annotation.Resources;
import javax.ejb.ActivationConfigProperty;
import javax.ejb.MessageDriven;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import javax.ejb.TransactionManagement;
import javax.ejb.TransactionManagementType;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.ObjectMessage;

import org.jboss.ejb3.annotation.ResourceAdapter;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@MessageDriven(name = "confEventQueue", activationConfig = {
		@ActivationConfigProperty(propertyName = "destinationType", propertyValue = "javax.jms.Queue"),
		@ActivationConfigProperty(propertyName = "destination", propertyValue = "java:/confEventQueue"),
})
@Resources({
	@Resource(name = "confEventQueue", mappedName="java:/confEventQueue", type = javax.jms.Destination.class)
})
@TransactionManagement(value= TransactionManagementType.CONTAINER)
@TransactionAttribute(value= TransactionAttributeType.REQUIRED)
@ResourceAdapter("hornetq-ra.rar")
	// Queue listener 
public class JcmConfListener implements MessageListener {

		private static final Logger LOGGER = LoggerFactory.getLogger(JcmConfListener.class);
		public JcmConfListener() {
			LOGGER.info("Started JcmConfListener");
		}
		@Override
		public void onMessage(Message rcvMsg) {
			try {
				ObjectMessage objMsg = (ObjectMessage) rcvMsg;
				LOGGER.info("JcmConfListener: Message Received=" + objMsg.getObject().toString());
			} catch (Exception e) {
				LOGGER.info("JcmConfListener: Message Received Failed {}",e);
				e.getStackTrace();
			}

		}
	}
