package com.tatacommunications.tp.jcm.xmpp;


import javax.annotation.PostConstruct;
import javax.annotation.Resource;
import javax.ejb.EJB;
import javax.ejb.Singleton;
import javax.ejb.Startup;
import javax.ejb.Timeout;
import javax.ejb.TimerConfig;
import javax.ejb.TimerService;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.tatacommunications.tp.jcm.dispatcher.ConfEvent;

@Startup
@Singleton
public class PubSubAdaptorBean {
	private static final Logger LOGGER = LoggerFactory.getLogger(PubSubAdaptorBean.class);
	private String TIMER_NAME = "XMPP_TIMER";
	
	private  @Resource TimerService timerService;
		
	@EJB
	private com.tatacommunications.tp.jcm.dispatcher.JcmDispatcherInterface jcmDispatcher;
	
	@PostConstruct
	void init()  {
		LOGGER.info("Starting timer");
		TimerConfig timerConfig = new TimerConfig(TIMER_NAME, false);
		timerService.createSingleActionTimer(5*1000, timerConfig);
		LOGGER.info("Init Completed");
	}
	
	@Timeout
	private void timerHandler(javax.ejb.Timer timer) {
		LOGGER.info("thread={}", Thread.currentThread().getName());

			ConfEvent testEvent;
			//for (int i = 0; i < 10; i++)
			{
				testEvent = new ConfEvent(Integer.toString(1), 11, 1);
				LOGGER.info("timerHandler: " + testEvent.toString());
				jcmDispatcher.queueConfEvent(testEvent);
			}
	}
}
